<?php

namespace ModulesGarden\HostingQuotaNotifications\Core\UI\Traits;

use \ModulesGarden\HostingQuotaNotifications\Core\UI\Interfaces\FormDataProviderInterface;
use \ModulesGarden\HostingQuotaNotifications\Core\Helper;

/**
 * Form DataProvider related functions
 *
 * @author Sławomir Miśkowicz <slawomir@modulesgarden.com>
 */
trait FormDataProvider
{
    
    /**
     * Providing save and load data functionalities for Forms
     * @var \ModulesGarden\HostingQuotaNotifications\Core\UI\Interfaces\FormDataProviderInterface
     */
    protected $dataProvider = null;
    protected $providerClass = '';

    public function loadProvider()
    {
        if ($this->providerClass != '' && !is_object($this->dataProvider))
        {
            $this->setProvider(Helper\di($this->providerClass));
        }
        
        return $this;
    }

    /**
     * Sets data provider for Form
     * @return $this
     */
    public function setProvider(FormDataProviderInterface $provider)
    {
        $this->dataProvider = $provider;

        return $this;
    }
    
    public function getFormData()
    {
        if($this->dataProvider === null)
        {
            $this->loadProvider();
        }
        
        return $this->dataProvider->getData();
    }
}
